routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Route::get('login/google', 'Auth\LoginController@redirectToProvider');
Route::get('login/google/callback', 'Auth\LoginController@handleProviderCallback');

Route::get('/', 'GuestController@index')->name('guest');

Auth::routes(['verify' => true]);

Route::group(['prefix' => 'internal', 'middleware' => ['role:admin|manager|staff']], function() {
    Route::get('/home', 'InternalController@index')->name('home');
    Route::resource('order', 'OrderController');
});

Route::group(['prefix' => 'internal', 'middleware' => ['role:admin|manager']], function() {
    Route::resource('hotel', 'HotelController');
    Route::resource('log', 'ActivityLogController');
    Route::resource('staff', 'StaffController');

});

Route::group(['prefix' => 'admin', 'middleware' => ['role:admin']], function() {
    Route::get('user', 'UserController@userIndex')->name('user.index');
    Route::get('user/{id}/view', 'UserController@userView')->name('user.view');
    Route::get('user/{id}/edit', 'UserController@userEdit')->name('user.edit');
    Route::patch('user/update', 'UserController@userUpdate')->name('user.update');
    Route::get('user/create', 'UserController@userCreate')->name('user.create');
    Route::post('user/store', 'UserController@store')->name('user.store');
    Route::delete('user/{id}/delete', 'UserController@destroy')->name('user.destroy');

});

Route::group(['prefix' => 'member', 'middleware' => ['verified','role:member']], function() {
    Route::get('/home', 'MemberController@index')->name('member.home');
    Route::patch('user/update', 'UserController@userUpdate')->name('member.user.update');
    Route::resource('booking', 'OrderController');
    // Route::get('/manage', ['middleware' => ['permission:manage-admins'], 'uses' => 'AdminController@manageAdmins']);
});



Route::get('/profile/edit', 'UserController@userEdit')->name('profile.edit');
Route::get('/profile/view', 'UserController@userView')->name('profile.view');

app/Staff.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Wildside\Userstamps\Userstamps;
use Spatie\Activitylog\Traits\LogsActivity;
use Illuminate\Database\Eloquent\SoftDeletes;


class Staff extends Model
{
    use Userstamps;
    use LogsActivity;
    use SoftDeletes;

    protected $fillable = [
        'user_id','hotel_id','staff_position'
    ];

    protected static $logFillable = true;

    public function user()
    {
        return $this->belongsTo('App\User','user_id','id');
    }
    public function hotel()
    {
        return $this->belongsTo('App\Hotel');
    }


}

app/Http/Controllers/InternalController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Hotel;
use Auth;

class InternalController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        $hotels = Hotel::where('manager_id', Auth::user()->id )->get();

        return view('internal.home',compact('hotels'));
    }
}

app/Http/Controllers/StaffController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Hotel;
use App\Staff;
use App\User;

use Carbon\Carbon;
use Auth;

class StaffController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        

        if(Auth::user()->hasRole('admin'))
            $staffs = Staff::paginate(15);

        
        if(Auth::user()->hasRole('manager')) {
            $hotels = Hotel::where('manager_id', Auth::user()->id )->get()->toArray();

            foreach ($hotels as $key => $value) {
                $hotelArray[] = $value['id'];
            }

            $staffs = Staff::whereIn('hotel_id', $hotelArray )->paginate(15);
        }
            
        return view('internal.staff.index', compact('staffs'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $staffs = User::whereRoleIs('staff')->get();
        
        if(Auth::user()->hasRole('admin'))
            $hotels = Hotel::all();

        if(Auth::user()->hasRole('manager'))
            $hotels = Hotel::where('manager_id', Auth::user()->id )->get();

        return view('internal.staff.create', compact('staffs','hotels'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // dd($request);
        $check = Staff::where('user_id',$request->user_id)->first();

        if($check) {
            $this->update($request);
            return redirect()->route('staff.show',$check->id)->withFlashSuccess('Staff Update Successfully');
        } else {
            $staff = New Staff;
            $staff->user_id = $request->user_id;
            $staff->hotel_id = $request->hotel_id;
            $staff->staff_position = $request->staff_position;
            $staff->save();

            activity()
            ->withProperties(['user' => $staff])
            ->log('New Staff Asigned');

            return redirect()->route('staff.show',$staff->id)->withFlashSuccess('Staff Asigned Successfully');
        }
        
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $user = Staff::findOrFail($id);

        return view('internal.staff.view', compact('user'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $user = Staff::findOrFail($id);
        
        if(Auth::user()->hasRole('admin'))
            $hotels = Hotel::all();

        if(Auth::user()->hasRole('manager'))
            $hotels = Hotel::where('manager_id', Auth::user()->id )->get();

        return view('internal.staff.edit', compact('user','hotels'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id = null)
    {
        if($id == null)
            $staff = Staff::where('user_id',$request->user_id)->first();
        else
            $staff = Staff::findOrFail($id);
        
        $staff->user_id = $request->user_id;
        $staff->hotel_id = $request->hotel_id;
        $staff->staff_position = $request->staff_position;
        $staff->save();

        activity()
        ->withProperties(['user' => $staff])
        ->log('Staff Asignment Updated');

        return redirect()->route('staff.show',$staff->id)->withFlashSuccess('Staff Update Successfully');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {

        $staff = Staff::findOrFail($id);

        activity()
        ->withProperties(['user' => $staff])
        ->log('Staff Asignment Deleted');
        
        $staff->delete();

        if($staff)
            return response()->json(['message' => 'success'], 200);
        else
            return response()->json(['message' => 'Staff is being used'], 400);

    }
}

resources/views/internal/staff/create.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">

{{ html()->form('POST', route('staff.store'))->class('form-horizontal')->open() }}
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Assign Staf to a Hotel</h6>
    </div>
    <div class="card-body">
        <div class="row mt-4 mb-4">
          <div class="col">
            <div class="form-group row">
              {{ html()->label('Name')->class('col-md-2 form-control-label')->for('user_id') }}
                <div class="col-md-10">
                    {{ html()->select('user_id', $staffs->pluck('name','id'))
                        ->class('form-control')
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Hotel')->class('col-md-2 form-control-label')->for('hotel_id') }}
                <div class="col-md-10">
                    {{ html()->select('hotel_id', $hotels->pluck('name','id'))
                        ->class('form-control')
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Position')->class('col-md-2 form-control-label')->for('staff_position') }}
                <div class="col-md-10">
                    {{ html()->text('staff_position')
                        ->class('form-control')
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
          </div>
        </div>

    </div>
    <div class="card-footer">
      <div class="row">
          <div class="col">
              <a href="{{ route('staff.index') }}" class="btn btn-danger btn-sm">Cancel</a>
          </div><!--col-->

          <div class="col text-right">
            <button type="submit" class="btn btn-sm btn-success"><i class="fa fa-save"></i> Update</button>
              {{-- {{ form_submit('Update') }} --}}
          </div><!--row-->
      </div><!--row-->
    </div><!--card-footer-->
  </div>
  {{ html()->form()->close() }}
</div>
@endsection

resources/views/internal/staff/edit.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">

{{ html()->form('PATCH', route('staff.update', $user->id ))->class('form-horizontal')->open() }}
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Assign Staf to a Hotel</h6>
    </div>
    <div class="card-body">
        <div class="row mt-4 mb-4">
          <div class="col">
            <div class="form-group row">
              {{ html()->label('Name')->class('col-md-2 form-control-label')->for('user_id') }}
                <div class="col-md-10">
                    {{ html()->text('user_id')
                        ->class('form-control')
                        ->value($user->user_id)
                        ->attributes(['hidden' => 'hidden']) }}
                    {{ html()->text('name')
                        ->class('form-control')
                        ->value($user->user->name)
                        ->attributes(['readonly' => 'readonly']) }}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Hotel')->class('col-md-2 form-control-label')->for('hotel_id') }}
                <div class="col-md-10">
                    {{ html()->select('hotel_id', $hotels->pluck('name','id'), $user->hotel_id)
                        ->class('form-control')
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Position')->class('col-md-2 form-control-label')->for('staff_position') }}
                <div class="col-md-10">
                    {{ html()->text('staff_position')
                        ->class('form-control')
                        ->value($user->staff_position)
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
          </div>
        </div>

    </div>
    <div class="card-footer">
      <div class="row">
          <div class="col">
              <a href="{{ route('staff.index') }}" class="btn btn-danger btn-sm">Cancel</a>
          </div><!--col-->

          <div class="col text-right">
            <button type="submit" class="btn btn-sm btn-success"><i class="fa fa-save"></i> Update</button>
              {{-- {{ form_submit('Update') }} --}}
          </div><!--row-->
      </div><!--row-->
    </div><!--card-footer-->
  </div>
  {{ html()->form()->close() }}
</div>
@endsection

resources/views/internal/staff/index.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">

  <!-- Page Heading -->
  <h1 class="h3 mb-2 text-gray-800">Staff List</h1>
  <p class="mb-4">Admin / Manager can list all staff and assign to a hotel.</p>

  <!-- DataTales Example -->
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">Staff List
      <a href="{{ route('staff.create') }}" type="button" class="btn btn-sm btn-primary float-right"><i class="fa fa-sign"></i> Assign Staff</a></h6>

    </div>
    <div class="card-body">
      <div class="table-responsive">
        <table class="table table-sm">
          <thead class="thead">
            <tr>
              <th class="text-center">#</th>
              <th class="text-center">Name</th>
              <th class="text-center">Position</th>
              <th class="text-center">Assigned to</th>
              <th class="text-center">Last Update</th>
              <th ></th>
            </tr>
          </thead>
          <tbody>
            @foreach ($staffs as $key => $staff)
              <tr>
                <td class="text-center">{{ $key+1 }}</td>
                <td>{{ $staff->user->name }}</td>
                <td>{{ $staff->staff_position }}</td>
                <td>{{ $staff->hotel->name }}</td>
                <td>{{ $staff->updated_at->diffForHumans() }}</td>
                <td >
                  <div class="btn-group" role="group" aria-label="User Actions">
                    <a href="{{ route('staff.show', $staff->id ) }}" data-toggle="tooltip" data-placement="top" title="" class="btn btn-info" data-original-title="View">
                        <i class="fas fa-eye"></i>
                    </a>
                    <a href="{{ route('staff.edit', $staff->id ) }}" data-toggle="tooltip" data-placement="top" title="" class="btn btn-primary" data-original-title="Edit">
                        <i class="fas fa-edit"></i>
                    </a>
                    <button type="button" id="btnDelete" data-id="{{$staff->id}}" data-name="{{$staff->name}}"  class="btn btn-danger btnDelete" >
                        <i class="fas fa-times"></i>
                    </button>
                </div>
                </td>
              </tr>
            @endforeach
          </tbody>
        </table>
        {{ $staffs->links()  }}
      </div>
    </div>
  </div>

</div>
@endsection
@push('after-scripts')
<script>
$(document).ready(function() {
    $('.btnDelete').each(function(index) {
        $(this).on("click", function(){
            var id = $(this).data('id');
            var name = $(this).data('name');
            var content = document.createElement('div');
                content.innerHTML = 'Anda yakin ingin hapus Staff dari Hotel? <code>'+name+'</code>';

            Swal.fire({
                // position: 'bottom-end',
                icon: 'error',
                title: 'Delete asigned Staff? Staff Detail Still Remain.',
                html: content,
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
                // toast: true,
                // timer: 3000,
                // showConfirmButton: false,

                // footer: '<a href>Why do I have this issue?</a>'
            }).then((result) => {
                if (result.value) {

                    $.ajax({
                        type: "DELETE",
                        url: "staff/"+id,

                        headers: {
                            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                        },
                        cache: false,
                        success: function(response) {
                            Swal.fire(
                            'Deleted!',
                            'Your Staff Asignment has been deleted.',
                            'success'
                            ).then(function() {
                                window.location.reload(1);
                            });

                        },
                        error: function (response) {
                            console.log(response.responseJSON.message);
                            Swal.fire(
                            'Error!',
                            response.responseJSON.message,
                            'error'
                            );
                        }
                    })

                }
                })
            });
        });
});
</script>
@endpush

resources/views/internal/staff/view.blade.php
@extends('layouts.backend')

@section('content')
<div class="container-fluid">
{{-- @role('member')
    {{ html()->modelForm($user, 'PATCH', route('member.user.update'))->class('form-horizontal')->acceptsFiles()->open() }}
@else
    {{ html()->modelForm($user, 'PATCH', route('user.update'))->class('form-horizontal')->acceptsFiles()->open() }}
@endrole --}}
  <div class="card shadow mb-4">
    <div class="card-header py-3">
      <h6 class="m-0 font-weight-bold text-primary">User Detail</h6>
    </div>
    <div class="card-body">
        <div class="row mt-4 mb-4">
          <div class="col-md-6">
            <div class="form-group row">
                

                    <div class="col-md-10">
                        <img class="img-profile rounded-circle mb-2" style="object-fit: cover;border-radius: 50%;
                    height: 200px;
                    width: 200px;" src="/storage/{{ $user->user->image_url ? $user->user->image_url : 'images/profiles/default.png' }}">
                      
                    </div><!--col-->
              </div><!--form-group-->
            <div class="form-group row">
            {{ html()->label('Asigned to Hotel')->class('col-md-2 form-control-label')->for('hotel') }}
                <div class="col-md-10">
                    {{ html()->text('Asigned to Hotel')
                        ->class('form-control')
                        ->value($user->hotel->name)
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Position')->class('col-md-2 form-control-label')->for('hotel') }}
                  <div class="col-md-10">
                      {{ html()->text('Position')
                          ->class('form-control')
                          ->value($user->staff_position)
                          ->required() }}
                  </div><!--col-->
              </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Name')->class('col-md-2 form-control-label')->for('name') }}
                <div class="col-md-10">
                    {{ html()->text('Name')
                        ->class('form-control')
                        ->placeholder('name')
                        ->attribute('maxlength', 191)
                        ->value($user->user->name)
                        ->required() }}
                </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Email')->class('col-md-2 form-control-label')->for('email') }}
                  <div class="col-md-10">
                      {{ html()->email('Email')
                          ->class('form-control')
                          ->placeholder('email')
                          ->attribute('maxlength', 191)
                          ->value($user->user->email)
                          ->required() }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Phone')->class('col-md-2 form-control-label')->for('phone') }}

                  <div class="col-md-10">
                      {{ html()->text('Phone')
                          ->class('form-control')
                          ->placeholder('phone')
                          ->attribute('maxlength', 191)
                          ->value($user->user->phone)
                          ->required() }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="form-group row">
              {{ html()->label('Address')->class('col-md-2 form-control-label')->for('address') }}

                  <div class="col-md-10">
                      {{ html()->text('Address')
                          ->class('form-control')
                          ->placeholder('address')
                          ->attribute('maxlength', 191)
                          ->value($user->user->address)
                          ->required() }}
                  </div><!--col-->
            </div><!--form-group-->
            <div class="row">

            </div>
            
            

    </div>
   
  </div>
  {{-- {{ html()->closeModelForm() }} --}}
</div>
@endsection